<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <div
            class="px-4 py-2 flex flex-col gap-2"
        >
            <navigation-bar />
            <credit-balance-box
                :credit-id="2"
            />
            <div
                class="border-b border-gray-400 pt-2 mb-2"
            />
            <div>
                <form-select
                    v-model="model.network"
                    :options="[
                        {value: 'BEP20', text: 'BEP20'},
                        {value: 'TRC20', text: 'TRC20'},
                    ]"
                    name="network"
                    :label="$t('network')"
                    :dark="true"
                    size="lg"
                    class="mb-4"
                />
                <form-input
                    v-model="model.to_crypto_address"
                    name="to_crypto_address"
                    :label="$t('crypto_address')"
                    :dark="true"
                    size="lg"
                    :note="computedWithdrawTitle"
                    class="mb-4"
                />
                <form-input
                    v-model="model.amount"
                    name="amount"
                    :label="$t('amount')"
                    :fund="true"
                    :dark="true"
                    :dollar-sign="true"
                    size="lg"
                    :note="computedMinWithdrawNote"
                />
            </div>
            <div
                v-if="withdrawalSetting"
                class="my-6 px-3"
            >
                <div
                    class="bg-gray-800 text-white px-4 py-3 rounded-lg"
                >
                    <div
                        class="flex justify-start leading-tight capitalize"
                    >
                        <div class="flex-1">
                            {{ $t('withdrawal_amount') }}
                        </div>
                        <div class="w-8">$</div>
                        <div class="w-16 overflow-y-scroll text-right">
                            {{ $helper.fundFormat(computedWithdrawalAmount) }}
                        </div>
                    </div>
                    <div
                        class="flex justify-start text-red-600 leading-tight capitalize"
                    >
                        <div class="flex-1">
                            -{{ $t('withdrawal_fee') }} ({{ withdrawalSetting.withdrawal_admin_fees_percentage}}%)
                        </div>
                        <div class="w-8">$</div>
                        <div class="w-16 overflow-y-scroll text-right">
                            {{ $helper.fundFormat(computedWithdrawalFee) }}
                        </div>
                    </div>
                    <div
                        class="flex justify-start font-black leading-tight capitalize"
                    >
                        <div class="flex-1">
                            {{ $t('receivable_amount') }}
                        </div>
                        <div class="w-8">$</div>
                        <div class="w-16 overflow-y-scroll text-right">
                            {{ $helper.fundFormat(computedReceivableAmount) }}
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="text-center"
            >
                There will be a Processing Fees of 2% and Gas Fee imposed for each withdrawal.
            </div>
            <auto-button
                :block="true"
                :busy="busy"
                :disabled="busy"
                class="tracking-wider uppercase text-2xl my-4"
                @click="password2Prompt = true"
            >
                {{ $t('withdraw') }}
            </auto-button>
            <div
                class="border-b border-gray-400 pt-2 mb-2"
            />
            <div>
                <div class="pl-2 font-black">{{ $t('withdrawal_history') }}</div>
            </div>
            <div
                class="mb-6 flex flex-col space-y-2"
            >
                <div
                    v-for="withdrawal in withdrawalRecords"
                    :key="withdrawal.id"
                    class="border-2 border-white rounded-lg px-2 py-4"
                >
                    <div
                        class="flex justify-between items-center space-x-2"
                    >
                        <div
                            class="text-2xl font-black"
                        >
                            {{ withdrawal.order_number }}
                        </div>
                        <div>
                            {{ withdrawal.status_explained }}
                        </div>
                    </div>
                    <div>
                        <div class="leading-tight font-mono">
                            {{ withdrawal.to_crypto_symbol }} {{ $helper.fundFormat(withdrawal.amount) }}
                        </div>
                        <div
                            v-if="withdrawal.network"
                            class="leading-tight"
                        >
                            <span class="capitalize">{{ $t('network') }}: </span>
                            <span class="font-mono">{{ withdrawal.network }}</span>
                        </div>
                        <div class="leading-tight">
                            <span class="capitalize">{{ $t('withdrawal_fee') }}: </span>
                            <span class="font-mono">{{ withdrawal.to_crypto_symbol }} {{ $helper.fundFormat(withdrawal.admin_fees_crypto) }}</span>
                        </div>
                        <div class="leading-tight">
                            <span class="capitalize">{{ $t('receivable_amount') }}: </span>
                            <span class="font-mono">{{ withdrawal.to_crypto_symbol }} {{ $helper.fundFormat(withdrawal.receivable_crypto_amount) }}</span>
                        </div>
                        <div class="leading-tight break-all">
                            <span class="capitalize">{{ $t('address') }}: </span><br>
                            {{ withdrawal.to_crypto_address }}
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <password2-prompt
            v-if="password2Prompt"
            @confirm="onPassword2Confirmed"
            @close="password2Prompt = false"
        />
    </div>
</template>

<script setup>
import {computed, inject, nextTick, onMounted, ref} from "vue";
import CreditBalanceBox from '~/components/credit/balance-box.vue';
import {useUserStore} from "~/stores/user.js";
import NavigationBar from "./navigation-bar.vue";
import {useI18n} from "vue-i18n";
import AutoButton from "~/components/button/auto-button.vue";
import FormInput from "~/components/form/form-input.vue";
import FormSelect from "~/components/form/form-select.vue";
import axios from "axios";
import BigNumber from "bignumber.js";
import Password2Prompt from "~/components/password2-prompt.vue";

const pageReady = ref(false);
const $helper = inject('$helper');
const $userStore = useUserStore();
const i18n = useI18n();

const model = ref({
    network: '',
    to_crypto_address: '',
    amount: '',
    current_password2: '',
});
const withdrawalSetting = ref(null);
const withdrawalRecords = ref([]);
const password2Prompt = ref(false);

const errors = ref({});
const busy = ref(false);

const computedWithdrawTitle = computed(() => {
    return String(i18n.t('please_make_sure_double_check_and_confirm_x_address')).replace(/___X___/i, i18n.t('usdt'));
});
const computedMinWithdrawNote = computed(() => {
    if (!withdrawalSetting.value || !withdrawalSetting.value.min_withdrawal_amount) return '';
    return String(i18n.t('minimum_withdraw_x_amount')).replace(/___X___/i, '$ ' + ($helper.fundFormat(withdrawalSetting.value.min_withdrawal_amount)));
});

const computedWithdrawalAmount = computed(() => {
    return new BigNumber(model.value.amount || 0);
});
const computedWithdrawalFee = computed(() => {
    if (!withdrawalSetting.value || !withdrawalSetting.value.withdrawal_admin_fees_percentage) return new BigNumber(0);
    if (!computedWithdrawalAmount.value) return new BigNumber(0);
    return computedWithdrawalAmount.value.div(new BigNumber(100)).times(new BigNumber(withdrawalSetting.value.withdrawal_admin_fees_percentage));
});
const computedReceivableAmount = computed(() => {
    return computedWithdrawalAmount.value.minus(computedWithdrawalFee.value);
});

onMounted(async () => {
    await $userStore.fetchAccount();
    await loadHistory(true);

    if (withdrawalRecords.value && withdrawalRecords.value.length) {
        model.value.to_crypto_address = withdrawalRecords.value[0].to_crypto_address;
    }

    pageReady.value = true;
});

const loadHistory = async (loadSetting) => {
    try {
        if (loadSetting) {
            const data = await axios.post('/credit/c2/withdrawal/load_history?setting=1');

            withdrawalRecords.value = data.models;
            withdrawalSetting.value = data.setting;
        } else {
            const data = await axios.post('/credit/c2/withdrawal/load_history');

            withdrawalRecords.value = data.models;
        }
    } catch (e) {
        console.log(e);
    }
}

const submitForm = async () => {
    if (!busy.value) {
        try {
            busy.value = true;

            const fd = new FormData();
            Object.keys(model.value).forEach(key => {
                fd.set(key, model.value[key]);
            });

            const data = await axios.post('/credit/c2/withdrawal/submit_form', fd);

            await $helper.alertSuccess({
                message: data.message,
                callback: async () => {
                    pageReady.value = false;

                    model.value.amount = '';
                    model.value.current_password2 = '';

                    await $userStore.fetchAccount();
                    await loadHistory();
                    await nextTick(() => {
                        pageReady.value = true;
                    });

                }
            })
        } catch (e) {
            console.log(e);
        } finally {
            busy.value = false;
        }
    }
};

const onPassword2Confirmed = async (payload) => {
    model.value.current_password2 = payload;
    password2Prompt.value = false;

    await submitForm();
};
</script>
